import { Construct } from 'constructs';
import { AmplifyGraphqlApiResources, FunctionSlot } from '../types';
/**
 * Everything below here is intended to help us gather the
 * output values and render out the L1 resources for access.
 *
 * This is done by recursing along the construct tree, and classifying the generated resources.
 *
 * @param scope root to search for generated resource against
 * @returns a mapping of L1 and L2 constructs generated by the Graphql Transformer.
 */
export declare const getGeneratedResources: (scope: Construct) => AmplifyGraphqlApiResources;
/**
 * Get the function slots generated by the Graphql transform operation, adhering to the FunctionSlot interface.
 * @param generatedResolvers the resolvers generated by the transformer to spit back out.
 * @returns the list of generated function slots in the transformer, in order to facilitate overrides.
 */
export declare const getGeneratedFunctionSlots: (generatedResolvers: Record<string, string>) => FunctionSlot[];
