import { Stack } from 'aws-cdk-lib';
import { Construct } from 'constructs';
/**
 * Given a scope, search up for the parent stack. This should be the nearest stack object.
 * @param scope the scope to search up against.
 * @returns the stack, if one can be found, else throws an error.
 */
export declare const getStackForScope: (scope: Construct, getRootStack?: boolean) => Stack;
/**
 * Utility to iteratively walk the construct tree starting at a particular node, executing a node processor at each step.
 * @param currentScope the scope to process.
 * @param processNode the fn to invoke on walk.
 */
export declare const walkAndProcessNodes: (currentScope: Construct, processNode: (scope: Construct) => void) => void;
