import { UserDefinedSlot } from '@aws-amplify/graphql-transformer-core';
import { FunctionSlot } from '../types';
/**
 * Validate that only supported props are being passed into the funciton slots.
 * @param functionSlots the slot inputs to validate.
 */
export declare const validateFunctionSlots: (functionSlots: FunctionSlot[]) => void;
/**
 * We'll partition any slots have both a request and response mapping template into two to make the existing system work.
 * @param functionSlots the possibly consolidated slots.
 * @returns no longer consolidated slots.
 */
export declare const separateSlots: (functionSlots: FunctionSlot[]) => FunctionSlot[];
/**
 * Given a set of strongly typed input params, generate a valid transformer slot name.
 * @param params the slot configuration
 * @returns the slot id
 */
export declare const getSlotName: (params: FunctionSlot) => string;
export declare const parseUserDefinedSlots: (userDefinedTemplates: FunctionSlot[]) => Record<string, UserDefinedSlot[]>;
